(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tsparticles-engine", "./RepulseBase"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.RepulseDiv = void 0;
    const tsparticles_engine_1 = require("tsparticles-engine");
    const RepulseBase_1 = require("./RepulseBase");
    class RepulseDiv extends RepulseBase_1.RepulseBase {
        constructor() {
            super();
            this.selectors = [];
        }
        get ids() {
            return (0, tsparticles_engine_1.executeOnSingleOrMultiple)(this.selectors, (t) => t.replace("#", ""));
        }
        set ids(value) {
            this.selectors = (0, tsparticles_engine_1.executeOnSingleOrMultiple)(value, (t) => `#${t}`);
        }
        load(data) {
            super.load(data);
            if (!data) {
                return;
            }
            if (data.ids !== undefined) {
                this.ids = data.ids;
            }
            if (data.selectors !== undefined) {
                this.selectors = data.selectors;
            }
        }
    }
    exports.RepulseDiv = RepulseDiv;
});
